/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.23
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "barriers"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "barriers"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *detailed_help_help; /**< @brief Print help, including all details and hidden options, and exit help description.  */
  const char *full_help_help; /**< @brief Print help, including hidden options, and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int verbose_flag;	/**< @brief Be verbose, i.e. print more information. (default=off).  */
  const char *verbose_help; /**< @brief Be verbose, i.e. print more information. help description.  */
  int quiet_flag;	/**< @brief Be quiet (also inhibit PS tree output). (default=off).  */
  const char *quiet_help; /**< @brief Be quiet (also inhibit PS tree output). help description.  */
  char * graph_arg;	/**< @brief Define type of the graph, i.e. configuration space. (default='RNA').  */
  char * graph_orig;	/**< @brief Define type of the graph, i.e. configuration space. original value given at command line.  */
  const char *graph_help; /**< @brief Define type of the graph, i.e. configuration space. help description.  */
  char * moves_arg;	/**< @brief Select the move-set for generating neighbors of a configuration (if Graph allows several different ones)..  */
  char * moves_orig;	/**< @brief Select the move-set for generating neighbors of a configuration (if Graph allows several different ones). original value given at command line.  */
  const char *moves_help; /**< @brief Select the move-set for generating neighbors of a configuration (if Graph allows several different ones). help description.  */
  int poset_arg;	/**< @brief Input is a poset from n objective functions. (default='0').  */
  char * poset_orig;	/**< @brief Input is a poset from n objective functions. original value given at command line.  */
  const char *poset_help; /**< @brief Input is a poset from n objective functions. help description.  */
  int connected_flag;	/**< @brief Restrict the output to the connected component. (default=off).  */
  const char *connected_help; /**< @brief Restrict the output to the connected component. help description.  */
  int bsize_flag;	/**< @brief Print the size of of each basin in output. (default=off).  */
  const char *bsize_help; /**< @brief Print the size of of each basin in output. help description.  */
  int ssize_flag;	/**< @brief Print saddle component sizes. (default=off).  */
  const char *ssize_help; /**< @brief Print saddle component sizes. help description.  */
  int max_arg;	/**< @brief Compute only the lowest <num> local minima. (default='100').  */
  char * max_orig;	/**< @brief Compute only the lowest <num> local minima. original value given at command line.  */
  const char *max_help; /**< @brief Compute only the lowest <num> local minima. help description.  */
  double minh_arg;	/**< @brief Print only minima with energy barrier greater than delta. (default='0.000001').  */
  char * minh_orig;	/**< @brief Print only minima with energy barrier greater than delta. original value given at command line.  */
  const char *minh_help; /**< @brief Print only minima with energy barrier greater than delta. help description.  */
  int saddle_flag;	/**< @brief Print the saddle point conformations in output. (default=off).  */
  const char *saddle_help; /**< @brief Print the saddle point conformations in output. help description.  */
  int rates_flag;	/**< @brief Compute rates between macro states (basins). (default=off).  */
  const char *rates_help; /**< @brief Compute rates between macro states (basins). help description.  */
  char * rates_text_file_arg;	/**< @brief Specify file name for the rates output. (default='rates.out').  */
  char * rates_text_file_orig;	/**< @brief Specify file name for the rates output. original value given at command line.  */
  const char *rates_text_file_help; /**< @brief Specify file name for the rates output. help description.  */
  char * rates_binary_file_arg;	/**< @brief Specify file name for the binary rates output. (default='rates.bin').  */
  char * rates_binary_file_orig;	/**< @brief Specify file name for the binary rates output. original value given at command line.  */
  const char *rates_binary_file_help; /**< @brief Specify file name for the binary rates output. help description.  */
  double noLP_rate_arg;	/**< @brief Scale rates of double moves for RNA-noLP (e.g. 0.01). (default='1.0').  */
  char * noLP_rate_orig;	/**< @brief Scale rates of double moves for RNA-noLP (e.g. 0.01). original value given at command line.  */
  const char *noLP_rate_help; /**< @brief Scale rates of double moves for RNA-noLP (e.g. 0.01). help description.  */
  int microrates_flag;	/**< @brief Compute microscopic rates between connected states. (default=off).  */
  const char *microrates_help; /**< @brief Compute microscopic rates between connected states. help description.  */
  double temp_arg;	/**< @brief Set temperature in degree centigrade. (default='37.0').  */
  char * temp_orig;	/**< @brief Set temperature in degree centigrade. original value given at command line.  */
  const char *temp_help; /**< @brief Set temperature in degree centigrade. help description.  */
  char ** path_arg;	/**< @brief Backtrack an optimal path between local minimum l2 and l1..  */
  char ** path_orig;	/**< @brief Backtrack an optimal path between local minimum l2 and l1. original value given at command line.  */
  unsigned int path_min; /**< @brief Backtrack an optimal path between local minimum l2 and l1.'s minimum occurreces */
  unsigned int path_max; /**< @brief Backtrack an optimal path between local minimum l2 and l1.'s maximum occurreces */
  const char *path_help; /**< @brief Backtrack an optimal path between local minimum l2 and l1. help description.  */
  char * mapstruc_arg;	/**< @brief Map conformations to minima in the tree..  */
  char * mapstruc_orig;	/**< @brief Map conformations to minima in the tree. original value given at command line.  */
  const char *mapstruc_help; /**< @brief Map conformations to minima in the tree. help description.  */
  char * mapstruc_output_arg;	/**< @brief Specify the filename for structure mapping output. (default='mapstruc.out').  */
  char * mapstruc_output_orig;	/**< @brief Specify the filename for structure mapping output. original value given at command line.  */
  const char *mapstruc_output_help; /**< @brief Specify the filename for structure mapping output. help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int detailed_help_given ;	/**< @brief Whether detailed-help was given.  */
  unsigned int full_help_given ;	/**< @brief Whether full-help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */
  unsigned int quiet_given ;	/**< @brief Whether quiet was given.  */
  unsigned int graph_given ;	/**< @brief Whether graph was given.  */
  unsigned int moves_given ;	/**< @brief Whether moves was given.  */
  unsigned int poset_given ;	/**< @brief Whether poset was given.  */
  unsigned int connected_given ;	/**< @brief Whether connected was given.  */
  unsigned int bsize_given ;	/**< @brief Whether bsize was given.  */
  unsigned int ssize_given ;	/**< @brief Whether ssize was given.  */
  unsigned int max_given ;	/**< @brief Whether max was given.  */
  unsigned int minh_given ;	/**< @brief Whether minh was given.  */
  unsigned int saddle_given ;	/**< @brief Whether saddle was given.  */
  unsigned int rates_given ;	/**< @brief Whether rates was given.  */
  unsigned int rates_text_file_given ;	/**< @brief Whether rates-text-file was given.  */
  unsigned int rates_binary_file_given ;	/**< @brief Whether rates-binary-file was given.  */
  unsigned int noLP_rate_given ;	/**< @brief Whether noLP-rate was given.  */
  unsigned int microrates_given ;	/**< @brief Whether microrates was given.  */
  unsigned int temp_given ;	/**< @brief Whether temp was given.  */
  unsigned int path_given ;	/**< @brief Whether path was given.  */
  unsigned int mapstruc_given ;	/**< @brief Whether mapstruc was given.  */
  unsigned int mapstruc_output_given ;	/**< @brief Whether mapstruc-output was given.  */

  char **inputs ; /**< @brief unnamed options (options without names) */
  unsigned inputs_num ; /**< @brief unnamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];
/** @brief all the lines making the full help output (including hidden options) */
extern const char *gengetopt_args_info_full_help[];
/** @brief all the lines making the detailed help output (including hidden options and details) */
extern const char *gengetopt_args_info_detailed_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the full help (including hidden options)
 */
void cmdline_parser_print_full_help(void);
/**
 * Print the detailed help (including hidden options and details)
 */
void cmdline_parser_print_detailed_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
